/* Get True ASCII characters from the source file and convert them 
   to Pet ASCII, then write them to the target file.  Stop when an 
   EOF (End of File) is encountered.
   
   Called with:
   
TRUE_PET  true_ASCII_file   Pet_ASCII_file

   Noel Nyman 3/90

*/

#include <stdio.h>
#include <ctype.h>
#include <io.h>

char sourcebuf[BUFSIZ * 16];                   /* source file buffer */
char targetbuf[BUFSIZ * 16];                   /* target file buffer */


main(argc, argv)
        int argc;
        char *argv[];


{
        int c, i=0;
        FILE *source, *target;
        char response='Y';
        char petfile[128], truefile[128];
                

        if (argc == 2)
            {    
            printf("TRUE_PET: must specify both source and target file\n");
            exit(1);
            }
        else if (argc == 1)
            {
            printf("File name of TRUE-ASCII file: ");
            gets(truefile);
            printf("File name of destination file: ");
            gets(petfile);
            }
        else 
            {
            strcpy(truefile,argv[1]);
            strcpy(petfile,argv[2]);
            }
                

        if (access(petfile, 0) == 0)   /* does target exist */
                do
                    {
                    printf("\n\"%s\" already exists - Overwrite (Y/N)? ", petfile);
                    response = getchar();
                    while (getchar() != '\n')
                        { ; }
                    response = toupper(response);
                    }         /* loop until Y or N */
                while (response != 'Y' && response != 'N');

        if (response == 'Y')    /* overwrite the file */
                {
                if ((source = fopen(truefile, "r")) == NULL)
                        printf("TRUE_PET: error opening \"%s\"\n", truefile);
                
                else if ((target = fopen(petfile, "w")) == NULL)
                        printf("TRUE_PET: error opening \"%s\"\n", petfile);

                else
                    { 
                    setvbuf( source, sourcebuf, _IOFBF, sizeof( sourcebuf ) );
                    setvbuf( target, targetbuf, _IOFBF, sizeof( targetbuf ) );

                    printf("Working .");
                    while ((c = getc(source)) != EOF)
                       {
                         if islower(c) 
                               putc(toupper(c), target);
                         else if isupper(c)
                               putc(c += 128,target);
                         else if (c == '\n')    /* don't pass line feeds */
                               putc(13, target);
                         else       
                               putc(c,target);


                         if (++i > 256)
                                {
                                 i = 0;
                                 printf(".");
                                }
                        }
                      fclose(source);
                      fclose(target);
                      printf("\n");
                    }
                }
   }


